;where did all the giants go?
;sensenstahl
;www.sensenstahl.com
;fasm 1.69.31
;listening: those who ride with giants - the respect for the old beast
;__________________________________________________________________________

;this one was inspired by the artwork for the album
;"those who ride with giants" by those who ride with giants (2o14). and it
;has some hints of shadow of the colossus and princess mononoke as
;well.

;no animation this time. in fact there are not much pure gfx in 256 bytes
;or less out there. and it still will be hard to challenge image by neon ;)

;the 1st draft was in greenish colors but since autumn hit with fog and
;grey skies i decided to make it dark and maybe a bit more atmospheric.
;anyway, enjoy! (while havin' a good ol' cup o' tea)
;__________________________________________________________________________

org 100h
use16

base equ 320*6+18 ;for the pos of the giants and their eyes

;assuming: cx = 255

start:   push 0a000h ;vga
         pop es
         push 08000h ;vscreen
         pop ds
         mov al,13h
         int 10h

main:

mov bp,320 ;save some bytes everywhere

;the god
;ch = 0 here
mov si,8
god:
mov cl,byte[cs:set01y+si-1] ;ch has to be 0
imul di,cx,320              ;y size
god2:
mov cl,byte[cs:set01x+si-1] ;x size
god1:
;imul bx,si,2 ;pos is word
mov bx,si ;-1b
mov bx,word[cs:set01p+bx+si-2]
add bx,cx

;mov ax,si
mov byte[ds:bx+di],20;al;21    ;draw 1st god (right side)
                               ;base pos is included in grabbed data

mov byte[ds:bx+di-40-320*6],23 ;draw 2nd god

loop god1

sub di,bp;320
jnz god2

dec si  ;do all segments
jnz god ;of the body

;draw 2 lines to indicate arms
;si = 0 here
;using si/loop saves 1b compared to using bx/jnz
;mov bx,320*40 ;=3200h
mov cl,20
arm_lines:
inc byte[ds:si+320*94+208+base];,22
inc byte[ds:si+320*90+226+base];,22 ;inc only gives 21 instead 22
                                    ;but it is fine enough
;sub bx,bp;320
;jnz arm_lines
add si,bp
loop arm_lines

;make mountains/trees
;xor ax,ax ;every frame the same
           ;can be skipped so save bytes
;xor cx,cx ;has to be 0 and it is 0 here from above

line1:
imul di,cx,320*5  ;starting level of line (y)

mov bx,bp;320       ;draw from right to left
line2:
dec ax           ;make things "random"
mul bx
rol ax,cl
mov dx,bp;320    ;move down
cmp al,111;121   ;or not?
jbe fine
neg dx           ;move up
fine:
add di,dx        ;move
mov si,di

mov dl,21        ;color works 
sub dl,cl        ;black in front(16), lighter color in the back(21)
down:
mov byte[ds:si+bx+120*320-1],dl ;draw top point of tree on 1st loop
add si,bp;320                   ;draw a line down to fill space
jno down
dec bx                          ;move left for next trees
jnz line2
inc cx
cmp cl,6
jne line1                       ;do all layers

;draw eyes of god
add byte[ds:320*64+214+base],cl;24    ;different (1st god/right)
inc cx                                ;+1 for the ray of light below
add byte[ds:320*64+219+base],cl;25    ;brightness (1st god/right)
                                      ;adding cl saves 2b compared to simply mov colors

add byte[ds:320*58+178+base],cl       ;middle eye on 2nd god
and byte[ds:320*60+178+base],cl       ;bottom eye on 2nd god

;make lines to separate pal bars
mov si,320*20-1
line:
mov byte[ds:si],cl;7;43;20
                  ;light gray is fine enough because it is visible at top and bottom
                  ;without popping up too much on both places
dec si
cmp si,320*178-1
jne line


;draw some lines
;for design
;bigger structures?
;an unknown bridge from shadow of the colossus?
;who knows. maybe the wind does

;cl = 7 here
dec bp ;save overall 1b below

design3:
imul di,cx,3;4 ;size up thickness
design2:
;mov bx,320*200+12;+182 ;base of all lines
;imul ax,cx,28          ;space between lines
;sub bx,ax              ;adjust pos of each line

imul bx,cx,-28;-34;-28          ;1b shorter
add bx,320*200+16

add byte[ds:320*56+178+base],bl   ;top eye/wek spot on 2nd god
                                  ;creating it here gives it a nice
                                  ;color for no extra cost

design1:
mov dl,22              ;color management
sub dl,cl
cmp byte[ds:di+bx],dl  ;don't draw
jbe neyney             ;where one should not draw
inc byte[ds:di+bx]     ;ray of light
cmp cl,7               ;leave it
jae nix                 ;only once
mov byte[ds:di+bx],dl  ;draw over all other rays of light
nix:

neyney:

;add some birds in the lower part
mul bx          ;decide if bird will be drawn
xor ax,di
cmp ah,ch ;0
jne neyneyney   ;nope
add si,bx       ;make pos
shr si,3        ;not all over the place

mov byte[ds:si+320*130-50],ch;0 draw birdo
neyneyney:
;no more birds

sub bx,bp;319
jnc design1  ;draw all the way up
dec di
jnz design2  ;do
loop design3 ;all lines

;setting up things (fill background, draw black bar[s])
;saves no bytes but adds some so flip stuff is the way to go

mov di,320*19 ;leave space on top to make a black bar
	;mov cx,320*180 ;e100h;320*160=c800h
mov ch,0c8h
flip:
mov al,22;170 ;aa =170
xchg al,byte[ds:di] ;grab vscreen
stosb              ;drop + inc di
loop flip

         in al,60h            ;read keyboard buffer
         dec al               ;esc needs to be pressed several times
         jnz main             ;nothing so go on
breaker:
         ret                  ;use the ret at rotate

;messy data of gods body which is made out of rectangles
set01x db 9,12,10,15,26,15,29,29
set01y db 50,13,50,50,50,8,50,50
set01p dw 320*57+212+base,320*58+210+base,320*74+205+base,320*73+214+base,320*77+204+base
set02p dw 320*59+209+base,320*80+202+base,320*82+204+base